
/*
 * 7 SEG for Artila
 *
 *       by Ace Yang
 *
 */



#include <linux/config.h>
#include <linux/types.h>
#include <linux/errno.h>
#include <linux/miscdevice.h>
#include <linux/slab.h>
#include <linux/ioport.h>
#include <linux/fcntl.h>
#include <linux/mc146818rtc.h>
#include <linux/netdevice.h>
#include <linux/sched.h>
#include <linux/delay.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/system.h>
#include <linux/delay.h>

int number_table[10]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x67};
//static DEFINE_SPINLOCK(seg_lock);

static int seg_ioctl(struct inode *inode, struct file *file,
		     unsigned int cmd, unsigned long arg);

//unsigned int seg_present = 0;

#define MISC_7SEG_MINOR 244
#define SEG_DRIVER	"7 SEG Driver v1.00"

static void seg_command(int command) {
	int i;
	unsigned int cmd;
	cmd = 0x800 + (command * 0x2);
	at91_set_gpio_output(AT91_PIN_PB18, 1);
	udelay(10);
	for(i=0;i<12;i++)
	{
		if (cmd & 0x800) 
			at91_set_gpio_output(AT91_PIN_PA21, 0);
		else
			at91_set_gpio_output(AT91_PIN_PA21, 1);
		at91_set_gpio_output(AT91_PIN_PD24, 1);
		udelay(10);
		at91_set_gpio_output(AT91_PIN_PD24, 0);
		cmd<<=1;
		udelay(10);
	} 
	at91_set_gpio_output(AT91_PIN_PA21, 0);
	udelay(10);
	at91_set_gpio_output(AT91_PIN_PB18, 0);
	udelay(10);
}

static void seg_wrtie_data(int addr , int data) {
	int i;
	unsigned int cmd;
	cmd = 0xa000 + (addr * 0x40) + (data*0x4);
	at91_set_gpio_output(AT91_PIN_PB18, 1);
	udelay(10);
	for(i=0;i<14;i++)
	{
		if (cmd & 0x8000) 
			at91_set_gpio_output(AT91_PIN_PA21, 0);
		else 
			at91_set_gpio_output(AT91_PIN_PA21, 1);
		at91_set_gpio_output(AT91_PIN_PD24, 1);
		udelay(10);
		at91_set_gpio_output(AT91_PIN_PD24, 0);
		cmd<<=1;
		udelay(10);
	} 
	at91_set_gpio_output(AT91_PIN_PA21, 0);
	udelay(10);
	at91_set_gpio_output(AT91_PIN_PB18, 0);
	udelay(10);
} 






static int seg_ioctl(struct inode *inode, struct file *file,
		     unsigned int cmd, unsigned long arg)
{
	//unsigned long address, a;
	return 0;

}


void demo_seg(char *buf) {
	int i , j;
	char bufs[128];
	int number[10]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x67};
	memset(bufs,0x00,128);
	for(i = 0 ; i < 21 ; i+=3) {
		bufs[i]   = ((number[9] & 0x1) << 3)+((number[8] & 0x1) << 2) +
				((number[7] & 0x1) << 1) +(number[6] & 0x1);
		bufs[i+1] =((number[5] & 0x1) << 3)+((number[4] & 0x1) << 2) +
				((number[3] & 0x1) << 1) +(number[2] & 0x1) ;
		bufs[i+2] =((number[1] & 0x1) << 3) +((number[0] & 0x1) << 2);
		for( j = 0 ; j < 10 ; j++)
			number[j] >>=1;
	}
	j = 0;
	for(i = 0 ; i < 0x2b ; i+=0x04) {
		seg_wrtie_data((0x00+i) , bufs[j]);
		seg_wrtie_data((0x01+i) , bufs[j+1]);
		seg_wrtie_data((0x02+i) , bufs[j+2]);
		j+=3;
	}
}

static int seg_open(struct inode *inode, struct file *file)
{
	int i = 0;
	//printk("open 2\n");
	at91_set_gpio_output(AT91_PIN_PA21, 0);
	at91_set_gpio_output(AT91_PIN_PD24, 0);
	at91_set_gpio_output(AT91_PIN_PB7 , 0);
	at91_set_gpio_output(AT91_PIN_PB18, 0);
	

	//seg_command(0x00);
	seg_command(0x24);
	//seg_command(0x14);
	seg_command(0xaf);
	seg_command(0x01);
	seg_command(0x03);
	/*for(i = 0 ; i < 0x2c ; i+=0x04) {
		seg_wrtie_data((0x00+i) , 0x0);
		seg_wrtie_data((0x01+i) , 0x0);
		seg_wrtie_data((0x02+i) , 0x0);
	}*/
	demo_seg("0123456789");
	/*spin_lock(&seg_lock);
	seg_present++;
	spin_unlock(&seg_lock);*/
	return 0;
}

static int seg_close(struct inode *inode, struct file *file)
{
	/*spin_lock(&seg_lock);
	seg_present--;
	spin_unlock(&seg_lock);*/
	return 0;
}

/*
 *	The various file operations we support.
 */

static struct file_operations seg_fops = {
	.ioctl = seg_ioctl,
	.open = seg_open,
 	.release = seg_close,
};

static struct miscdevice seg_dev = {
	MISC_7SEG_MINOR,
	"7seg",
	&seg_fops
};

static int seg_init(void)
{
	int ret;
	//unsigned long data;

	ret = misc_register(&seg_dev);
	if (ret) {
		printk(KERN_WARNING  "Unable to register misc device.\n");
		return ret;
	}
	printk("Artila 7 Seg Driver Version 1.0 .\n");
	at91_set_gpio_output(AT91_PIN_PA21, 0);
	at91_set_gpio_output(AT91_PIN_PD24, 0);
	at91_set_gpio_output(AT91_PIN_PB7 , 0);
	at91_set_gpio_output(AT91_PIN_PB18, 0);
	
	return 0;		
	
}

static void __exit seg_exit(void)
{
	misc_deregister(&seg_dev);
}



module_init(seg_init);
module_exit(seg_exit);

MODULE_AUTHOR("Ace Yang");
MODULE_LICENSE("GPL");
