 /*  Header File for Artial Matrix500
 *
 *  Copyright (C) 2006 Artila Electronics,Ltd.
 *
 *  Purpose: For Artila's specific devices
 *  For example, GPIO, 3in1 serial port setting, EEPRORM
 *  read/write......and so on.
 *
 *  Note 1: Other devices are compliant to standard Linux's API
 *  Note 2: For details, please refer to the examples which are 
 *          provided by Artila.
 */

#ifndef _MATRIX500_H_
#define _MATRIX500_H_

/* /dev/gpio, GPIO IOCTL Commands */
#define GPIO_IOCTL_COUNT	0
#define GPIO_IOCTL_DIPSW	1
#define GPIO_IOCTL_GET		2
#define	GPIO_IOCTL_SET		3
#define	GPIO_IOCTL_CLEAR	4
#define GPIO_IOCTL_OUTPUT	5
#define GPIO_IOCTL_INPUT	6
#define GPIO_IOCTL_MODE		7

/* /dev/ttyS1, Serial Port IOCTL Commands */
#define UC500_GET_UART_TYPE	0xe001  
#define UC500_SET_UART_TYPE	0xe002	
/* Parameters */
#define UC500_UART_TYPE_232	232
#define UC500_UART_TYPE_422	422
#define UC500_UART_TYPE_485	485

/* EEPROM is accessed via Linux's sysfs scheme */
/* Please refer to Matrix500 example and Linux documentation */

/*
 * Function command codes for io_ctl.
 */
#define LCD_On			1
#define LCD_Off			2
#define LCD_Clear		3
#define LCD_Reset		4
#define LCD_Cursor_Left		5
#define LCD_Cursor_Right	6
#define LCD_Disp_Left		7
#define LCD_Disp_Right		8
#define LCD_Get_Cursor		9
#define LCD_Set_Cursor		10
#define LCD_Home		11
#define LCD_Read		12
#define LCD_Write		13
#define LCD_Cursor_Off		14
#define LCD_Cursor_On		15
#define LCD_Get_Cursor_Pos	16
#define LCD_Set_Cursor_Pos	17
#define LCD_Blink_Off           18
#define LCD_Back_On		19
#define LCD_Back_Off		20


#define LCD_CHARS_PER_LINE 18

struct lcd_display {
        int size1;
        int size2;
        unsigned char line1[LCD_CHARS_PER_LINE];
        unsigned char line2[LCD_CHARS_PER_LINE];
        unsigned char cursor_address;
        unsigned char character;
        unsigned char *RomImage;
};


#endif
